## valkey 8.0.6+dfsg1

=== Makefile ===
# Top level makefile, the real magic is at src/Makefile

default: all

.DEFAULT:
	cd src && $(MAKE) $@

install:
	cd src && $(MAKE) $@

.PHONY: install
