=== debian/changelog ===
valkey (8.1.3+dfsg1-0ubuntu1) questing; urgency=medium

  * New upstream version 8.1.3 (LP: #2115258)
    - Security fixes:
      + CVE-2025-32023: Out-of-bounds write during hyperloglog operations.
      + CVE-2025-48367: IP Protocol errors resulting in DoS.
      + CVE-2025-27151: AOF file name length not checked.
    - Bug fixes:
      + Fix missing response when AUTH is errored inside a transaction.
      + Properly escape double quotes and backslash in sdscatrepr.
      + Fix random element in skewed sparse hash table.
      + Only mark the client reprocessing flag when unblocked on keys.
      + Fix memory corruption in sharded pubsub unsubscribe.
      + Free module context even if there was no content written in auxsave2.
      + Detect SSL_new() returning NULL in outgoing connections.
      + Correctly cast the extension lengths.
      + Fix cluster myself CLUSTER SLOTS/NODES wrong port after updating
        port/tls-port.
      + Fix replica can't finish failover when config epoch is outdated.
      + Fix CLIENT UNBLOCK ability to unpause paused clients.
  * d/p/fix-8.1.x-multi-unit-test.patch: Fix multi unit test issue in new
    version.
  * d/p/0005-Incorporate-Redis-CVE-for-CVE-2025-27151-2146.patch: Remove- fixed
    upstream in 8.1.2.

 -- Lena Voytek <lena.voytek@canonical.com>  Mon, 07 Jul 2025 16:21:10 -0400

valkey (8.1.1+dfsg1-2ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2110459). Remaining changes:
    - Redis compatibility and migration:
      + d/bin/generate-systemd-service-files: do not start the services if
        Redis migration happened.
      + d/control: add valkey-redis-compat binary package paragraph.
      + d/{README.Debian,valkey-redis-compat.NEWS}: document how the Redis.
        migration works.
      + d/valkey-redis-compat.links: create compatibility symlinks for Redis.
      + d/valkey-redis-compat.postinst: migrate data and config from Redis.
      + d/tests: test Redis migration via DEP-8 test.
    - d/tests: use systemctl instead of service to restart valkey.
    - d/t/control: explicitly add Depends for each test.
    - d/rules: remove "|| true" from testing calls.
  * d/valkey-redis-compat.postinst: Do not migrate on upgrade if redis files
    have already been migrated (LP: #2104217).
  * d/rules: Skip memefficiency unit tests due to missing activedefrag
    in system jemalloc.

 -- Lena Voytek <lena.voytek@canonical.com>  Fri, 13 Jun 2025 13:04:10 -0400
