=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  procps <!nocheck>,
  tcl <!nocheck>,
  tcl-tls <!nocheck>,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://valkey.io
 Vcs-Git: https://salsa.debian.org/debian/valkey.git
 Vcs-Browser: https://salsa.debian.org/debian/valkey
